ad_page_contract {
    display all assignments of a community
    @author: marmoser at wu.ac.at
} -properties {
}

if {![ns_conn isconnected]} {
    return
}

#display all available assignments sorted by the publication date
set html ""
set url ""
set user_id [ad_conn user_id]
# get portlet parameters
array set config $cf
# get shades status
set shaded_p $config(shaded_p)
if { $config(shaded_p) == "t" } {
    # return directly to the adp-Wrapper
    return
}

# check if we are inside of a community
if {[dotlrn_community::get_community_id] ne ""} {
    set in_community_context_p 1
} else {
    set in_community_context_p 0
}

# get list of package id's
# set list_of_package_ids 0
if { [info exists config(package_id)] } {
    foreach pkg $config(package_id) {
         if {$pkg > 0} {
            lappend list_of_package_ids $pkg
         } else {
             lappend list_of_package_ids "0"
         }
    }
    # set list_of_package_ids $config(package_id)
} else {
    set list_of_package_ids "-1"
}
# initialize total number of output rows
set num_rows 0
# get two list of package id's in which the current user has student/lecturer privileges
set sql "
  SELECT
        distinct dca.package_id,
        dc.community_id
    FROM
        dotlrn_applets da,
        dotlrn_community_applets dca,
        dotlrn_communities dc,
        dotlrn_member_rels_approved dmra
    WHERE
        dca.applet_id = da.applet_id
        AND
        da.package_key = 'tlf-assignments'
        AND dc.archived_p = 'f'
        AND dca.community_id = dc.community_id
        AND dca.package_id is not null
        AND dmra.community_id = dc.community_id
        AND dmra.user_id = :user_id
        AND dca.package_id IN ([join $list_of_package_ids ", "]);"
# run query
if {[lindex $list_of_package_ids 0]>0} {
    set tlf_applet_list [::xo::dc list_of_lists tlf_applets $sql]
    ns_log warning "funk  $tlf_applet_list $list_of_package_ids"
} else {
    set tlf_applet_list ""
}
set admin_packages [list]
set student_packages [list]
foreach item $tlf_applet_list {
    set comm [lindex $item 1]
    set pkg_id [lindex $item 0]
    if {$in_community_context_p} {
        append url "<a href='[apm_package_url_from_id $pkg_id]'>Link</a>"
    }
    set applet_key [::ast_installer applet_key]
    set item [list [lindex $item 0] $comm]
    if {$item ni $admin_packages && [permission::permission_p -object_id [lindex $item 0] -privilege "admin"]} {
        lappend admin_packages $item
        set admin_communities($item) $item
    } elseif {$item ni $student_packages} {
        lappend student_packages $item
        set student_communities($item) $item
    }
}
################################################################################


################################################################################
# admin
if { [info exists admin_packages] } {
    # create output object
    template::multirow create admin_data community_name page_name page_url finish_date nr_submissions
    foreach item $admin_packages {
        set package_id [lindex $item 0]
        set community_id [lindex $item 1]
        if {[catch {::xowiki::Package initialize -package_id $package_id} err]} {
               ns_log notice "package initialize failed $err"
               continue
       }
        set display_members [parameter::get -package_id $package_id -parameter member_display -default 0]
        set community_id [lindex $item 1 0]
        set comm_clause [expr {$display_members ? "-community_id $community_id" : ""}]
        set cmd "::tlf_cassignments::get_all_counts -package_id $package_id -display_members $display_members $comm_clause"
        set community_page "[dotlrn_community::get_community_name $community_id]"
        foreach {row submissions} [{*}$cmd] {
            if {![regexp {(\d*)_submitted} [lindex $row 0] match ast_id]} {continue}
            if {![catch {set ast [::xo::db::CrClass get_instance_from_db -item_id $ast_id]} errMsg] } {
                set page_url "[apm_package_url_from_id $package_id]?view=[$ast set item_id]"
                set page_name [$ast set title]
                set finish_date "[$ast germanize_date time_to]"
                template::multirow append admin_data $community_page $page_name $page_url $finish_date $submissions
            } else {
                ns_log Notice "non existing assignment_id: $ast_id - $errMsg"
            }
        }
    }
    template::multirow sort admin_data -decreasing finish_date
    template::multirow sort admin_data -dictionary -increasing community_name
    template::multirow foreach admin_data {
        incr num_rows
    }
}

################################################################################


################################################################################
# student

if { [info exists student_packages] } {
    template::multirow create student_data community_name page_name page_url status_abgabe status_abgabe_class finish_date
    foreach item $student_packages {
        set package_id [lindex $item 0]
        set community_name [dotlrn_community::get_community_name [lindex $item 1 0]]
        if {[catch {::xowiki::Package initialize -package_id $package_id} err]} {
            ns_log notice "package initialize failed: $err"
            continue
       }
        set base_item [string trimleft [$package_id resolve_page create-assignment.wf method_var] :]
        set sql {
            select item_id
                from xowiki_form_instance_item_index
                where package_id = :package_id
                and page_template = :base_item
                and state = 'published'
                order by hkey->'time_to' asc
        }
        foreach ast_id [::xo::dc list get_assignments $sql] {
            set ast [::xo::db::CrClass get_instance_from_db -item_id $ast_id]
            set page_name [$ast set title]
            set page_url "[expr {[info exists shared_community([lindex $item 1 0])] && !$in_community_context_p?"[dotlrn_community::get_community_url [lindex $item 1 0]]":""}][$ast pretty_link ]"
            set finish_date "#tlf-assignments.end#: [$ast germanize_date time_to]"
            set is_enabled [expr {[$ast check_submittable 0] eq "" ? 0 : 1}]
            if {$is_enabled} {
                set nf [$ast germanize_date ${user_id}_nachfrist]
                if {$nf ne ""} {
                    set finish_date "#tlf-assignments.nachfrist#: $nf"
                }
                set abgabe "abgabe_[$ast set item_id]__[lindex [$ast checkgroup [::xo::cc user_id]] 1]"
                set abgabe_id [$package_id lookup -name $abgabe]
                set status_abgabe "#tlf-assignments.missing#"
                set status_abgabe_class "abgaben n10"
                 if {$abgabe_id > 0} {
                    ::xo::db::CrClass get_instance_from_db -item_id $abgabe_id
                        switch [$abgabe_id set state] {
                            initial {
                                set status_abgabe "#tlf-assignments.is_open#"
                                set status_abgabe_class "abgaben n11"
                            }
                            submitted {
                                set status_abgabe ""
                                set status_abgabe_class ""
                            }
                            grade_state {
                                set status_abgabe ""
                                set status_abgabe_class ""
                            }
                            graded {
                                set status_abgabe ""
                                set status_abgabe_class ""
                            }
                        }
                    set page_url "[expr {[info exists shared_community([lindex $item 1 0])]  && !$in_community_context_p?"[dotlrn_community::get_community_url [lindex $item 1 0]]":""}][$abgabe_id pretty_link]"
                    set resubmission [$abgabe_id germanize_date resubmissionff]
                    if {$resubmission ne ""} {
                        set finish_date "#tlf-assignments.resub_deadline#: $resubmission"
                        set status_abgabe "#tlf-assignments.resub_open#"
                        set status_abgabe_class "abgaben n11"
                    }
                }
                template::multirow append student_data $community_name $page_name $page_url $status_abgabe $status_abgabe_class $finish_date
            }
        }
    }
    template::multirow foreach student_data {
        incr num_rows
    }
}
